#!/bin/gawk -f

function parse_ethers()
{
	curif=0
        while (getline < "/etc/ethers") {
	    if (match($0, /^([:[:alnum:]]+) ([[:alnum:]]+)/)) {
		macaddr=gensub(/^([:[:alnum:]]+) ([[:alnum:]]+)/, "\\1", "g", $0)
		alias=gensub(/^([:[:alnum:]]+) ([[:alnum:]]+)/, "\\2", "g", $0)
		ethers[toupper(macaddr)]=alias
	    }
	}
}

BEGIN {
    parse_ethers()
    for (i=1; i < ARGC; i++) {
	delete stainfo
	while (getline < ARGV[i]) {
	    if (match($0, /^([_\[\]=[:alnum:]])+=(.*)/)) {
		varname=gensub(/^([_\[\][:alnum:]]+)=(.*)/, "\\1", "g", $0)
		varvalue=gensub(/^([_\[\][:alnum:]]+)=(.*)/, "\\2", "g", $0)
		stainfo[varname]=varvalue
	    }
	    if (match($0, /^last_rx: silence=([[:digit:]]+) signal=([[:digit:]]+) rate=([[:digit:]]+) flow=([[:digit:]]+)/)) {
		stainfo["lrx_silence"]=gensub(/^last_rx: silence=([[:digit:]]+) signal=([[:digit:]]+) rate=([[:digit:]]+) flow=([[:digit:]]+)/, "\\1", "g", $0)
		stainfo["lrx_signal"]=gensub(/^last_rx: silence=([[:digit:]]+) signal=([[:digit:]]+) rate=([[:digit:]]+) flow=([[:digit:]]+)/, "\\2", "g", $0)
		stainfo["lrx_rate"]=gensub(/^last_rx: silence=([[:digit:]]+) signal=([[:digit:]]+) rate=([[:digit:]]+) flow=([[:digit:]]+)/, "\\3", "g", $0)
	    }
	}
	close(ARGV[i])
	if (ethers[toupper(stainfo["STA"])] == "")
	    alias=toupper(stainfo["STA"])
	else
	    alias=ethers[toupper(stainfo["STA"])]

	printf "%-17s %-14s %-16s %-10s %-10s\n", alias,
	    stainfo["lrx_signal"] "/" stainfo["lrx_silence"],
	    stainfo["tx_rate"] "/" stainfo["lrx_rate"],
	    stainfo["tx_bytes"], stainfo["rx_bytes"]
    }
}
		